routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Auth::routes();
Route::any('/admin', 'AdminController@index')->name('admin.admin')->middleware('check-perm');


Route::any('/', 'HomeController@index')->name('home');

Route::any('/dashboard', 'AdminController@index')->name('admin')->middleware('check-perm');

//
Route::any('/user/list', 'UserController@list')->name('user_list');
Route::any('/user/create', 'UserController@create')->name('user_create');
Route::any('/user/update/{user}', 'UserController@update')->name('user_update');
Route::any('/user/delete/{user}', 'UserController@delete')->name('user_delete');
Route::any('/user/profil', 'UserController@myProfil')->name('user_profil');

// role
Route::any('/role/list', 'RoleController@list')->name('role_list');
Route::any('/role/create', 'RoleController@create')->name('role_create')->middleware('check-perm');
Route::any('/role/update/{role}', 'RoleController@update')->name('role_update');
Route::any('/role/delete/{role}', 'RoleController@delete')->name('role_delete');

// ressource
Route::any('/ressource/list', 'RessourceController@list')->name('ressource_list');
Route::any('/ressource/create', 'RessourceController@create')->name('ressource_create');
Route::any('/ressource/update/{ressource}', 'RessourceController@update')->name('ressource_update');
Route::any('/ressource/delete/{ressource}', 'RessourceController@delete')->name('ressource_delete');

// fonctionnalite
Route::any('/fonctionnalite/list', 'FonctionnaliteController@list')->name('fonctionnalite_list');
Route::any('/fonctionnalite/create', 'FonctionnaliteController@create')->name('fonctionnalite_create');
Route::any('/fonctionnalite/update/{fonctionnalite}', 'FonctionnaliteController@update')->name('fonctionnalite_update');
Route::any('/fonctionnalite/delete/{fonctionnalite}', 'FonctionnaliteController@delete')->name('fonctionnalite_delete');

// apparence
Route::any('/apparence/list', 'ApparenceController@list')->name('apparence_list');
Route::any('/apparence/create', 'ApparenceController@create')->name('apparence_create');
Route::any('/apparence/update/{apparence}', 'ApparenceController@update')->name('apparence_update');
Route::any('/apparence/delete/{apparence}', 'ApparenceController@delete')->name('apparence_delete');

// quickyproject
Route::resource('quickyproject', 'QuickyprojectController')->except(['show']);
Route::get('quickyproject/data', 'QuickyprojectController@data')->name('quickyproject.data');

// menu
Route::any('/menu/list', 'MenuController@list')->name('menu_list');
Route::any('/menu/create', 'MenuController@create')->name('menu_create');
Route::any('/menu/update/{menu}', 'MenuController@update')->name('menu_update');
Route::any('/menu/delete/{menu}', 'MenuController@delete')->name('menu_delete');

app/Models/Quickyproject.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Yajra\DataTables\DataTables;

class Quickyproject extends Model
{
    protected $table = 'quickyprojects';
    protected $guarded = [];

    


    public static function getDataForDataTable()
        {
            $query = self::query()->where('deleted', '0');

            return DataTables::of($query)
                ->addColumn('action', function ($quickyproject) {
                    return view('back.quickyproject.actions', compact('quickyproject'))->render();
                })
                ->rawColumns(['action'])
                ->make(true);
        }
}

app/Http/Controllers/QuickyprojectController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Quickyproject;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\RedirectResponse;

class QuickyprojectController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    protected function getRules(): array
    {
        return [
        ];
    }

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return Response
     */
    public function index(Request $request): Response
    {
        $request->flash();
        return response()->view('back.quickyproject.index',
            [
                'records' => Quickyproject::all()->where('deleted', "0")
            ]
        );
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create(): Response
    {
        $viewsData = [];
        return response()->view('back.quickyproject.create', $viewsData);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @return RedirectResponse|void
     */
    public function store(Request $request)
    {
        $rules = [];
        $validator = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
            return redirect()->back()->withInput()->withErrors($validator);
        } else {
            Quickyproject::create($request->all());
            Redirect::to(route('quickyproject.index'))->send();
        }
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param Quickyproject $quickyproject
     * @return Response
     */
    public function edit(Quickyproject $quickyproject): Response
    {
        $viewsData['record'] = $quickyproject;

        return response()->view('back.quickyproject.edit', $viewsData);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param Quickyproject $quickyproject
     * @param Request $request
     * @return RedirectResponse
     */
    public function update(Quickyproject $quickyproject, Request $request): RedirectResponse
    {
        //
        $data = $request->all();
        $rules = [];
        $validator = Validator::make($request->all(), $rules);
        if ($validator->fails()) {
            return redirect()->back()->withInput()->withErrors($validator);
        } else {
            $quickyproject->update($request->all());
            Redirect::to(route('quickyproject.index'))->send();
        }
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param Quickyproject $quickyproject
     * @return JsonResponse
     */
    public function destroy(Quickyproject $quickyproject): JsonResponse
    {
        $quickyproject->update(['deleted' => 1, 'deleted_at' => date("Y-m-d H:i:s"), 'deleted_by' => Auth::user()->id]);
        return response()->json(['success' => true, 'message' => "L'enregistrement a été supprimé avec succès"]);
    }


    public function data()
            {
               return quickyproject::getDataForDataTable();
            }
}

resources/views/back/quickyproject/actions.blade.php
<div>
{{--    <a href="{{ route('quickyproject.edit', ['quickyproject' => $quickyproject->id]) }}">--}}
{{--        <i class="material-icons tooltipped" data-position="top" data-tooltip="Modifier">edit</i>--}}
{{--    </a>--}}
{{--    <a href="#!" onclick="openSuppModal({{ $quickyproject->id }})">--}}
{{--        <i class="material-icons tooltipped" style="color: #c10027;" data-position="top" data-tooltip="Supprimer">delete</i>--}}
{{--    </a>--}}
</div>

resources/views/back/quickyproject/create.blade.php
@extends($layout)

@section('content')
<div id="breadcrumbs-wrapper" class="breadcrumbs-bg-image gradient-45deg-blue-grey-blue">
    <!-- Search for small screen-->
    <div class="container">
        <div class="row">
            <div class="col s12 m6 l6">
                <h5 class="breadcrumbs-title mt-0 mb-0"><span>Gestion des quickyprojects</span></h5>
            </div>
            <div class="col s12 m6 l6 right-align-md">
                <ol class="breadcrumbs mb-0 mt-0">
                    <li class="breadcrumb-item"><a href="{{route('admin')}}">Accueil</a>
                    </li>
                    <li class="breadcrumb-item"><a href="{{route('quickyproject.index')}}">Liste des quickyprojects</a>
                    </li>
                </ol>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col s12">
        <div class="container">
            <div class="section">
                <form method="POST" action="{{route('quickyproject.store')}}">
                    @csrf
                    <br>
                    <div class="card">
                        <div class="card-panel">
                            <div class="row">
                                <div class="col s12 m12">
                                    <div class="row">

                                        <div class="col s12 input-field">
                                            <input id="name" name="name" value="{{old('name')}}" autocomplete="off"
                                            readonly onfocus="this.removeAttribute('readonly');" type="text">
                                            <label for="name"> Nom </label>
                                            @error('name')
                                                <span class="helper-text materialize-red-text">{{ $message }}</span>
                                            @enderror
                                        </div>
                                        <div class="col s12 input-field">
                                            <input id="id_project" name="id_project" value="{{old('id_project')}}" autocomplete="off"
                                            readonly onfocus="this.removeAttribute('readonly');" type="text">
                                            <label for="id_project"> Id du projet </label>
                                            @error('id_project')
                                                <span class="helper-text materialize-red-text">{{ $message }}</span>
                                            @enderror
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col s12 m12">
                                    <div class="col s12 display-flex justify-content-end mt-3">
                                        <a href="{{route('quickyproject.index')}}"><button type="button"
                                                class="btn btn-light">Retour </button></a>
                                        <button type="submit" class="btn indigo" style="margin-left: 1rem;">
                                            Enregistrer</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@stop

resources/views/back/quickyproject/edit.blade.php
@extends($layout)
@section('content')
<div class="row">
    <div class="col s12">
        <div class="container">
            <div class="section">

                <form method="POST" action="{{route('quickyproject.update', ['quickyproject' => $record->id])}}">
                    @csrf
                    @method('PUT')
                    <br>
                    @if (Session::has('success'))
                    <div class="card-alert card green">
                        <div class="card-content white-text">
                            <p>{{ Session::get('success') }} </p>
                        </div>
                        <button type="button" class="close white-text" data-dismiss="alert" aria-label="Close">
                            <span aria-hidden="true">×</span>
                        </button>
                    </div>
                    @endif
                    <div class="card">
                        <div class="card-panel">
                        <div class="row">
                                <div class="col s12 m12">
                                    <div class="row">
                                                        
                                        <div class="col s12 input-field">
                                            <input id="name" name="name" value="{{old('name', $record->name)}}" autocomplete="off"
                                            readonly onfocus="this.removeAttribute('readonly');" type="text">
                                            <label for="name"> Nom </label>
                                            @error('name')
                                                <span class="helper-text materialize-red-text">{{ $message }}</span>
                                            @enderror
                                        </div>                
                                        <div class="col s12 input-field">
                                            <input id="id_project" name="id_project" value="{{old('id_project', $record->id_project)}}" autocomplete="off"
                                            readonly onfocus="this.removeAttribute('readonly');" type="text">
                                            <label for="id_project"> Id du projet </label>
                                            @error('id_project')
                                                <span class="helper-text materialize-red-text">{{ $message }}</span>
                                            @enderror
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col s12 m12">
                                    <div class="col s12 display-flex justify-content-end mt-3">
                                        <a href="{{route('quickyproject.index')}}"><button type="button"
                                                class="btn btn-light">Retour </button></a>
                                        <button type="submit" class="btn indigo" style="margin-left: 1rem;">
                                            Enregistrer</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@stop

resources/views/back/quickyproject/index.blade.php
@extends($layout)
@section('content')
    <div id="breadcrumbs-wrapper" class="breadcrumbs-bg-image gradient-45deg-blue-grey-blue">
        <!-- Search for small screen-->
        <div class="container">
            <div class="row">
                <div class="col s12 m6 l6">
                    <h5 class="breadcrumbs-title mt-0 mb-0"><span>Gestion des quickyprojects</span></h5>
                </div>
                <div class="col s12 m6 l6 right-align-md">
                    <ol class="breadcrumbs mb-0 mt-0">
                        <li class="breadcrumb-item"><a href="{{route('admin')}}">Accueil</a>
                        </li>
                        <li class="breadcrumb-item"><a href="{{route('quickyproject.index')}}">Liste des
                                quickyprojects</a>
                        </li>
                    </ol>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col s12">
            <div class="container">
                <div class="section">
                    <br>
                    <div class="list-table" id="app">
                        <div class="card">
                            <div class="card-content">
                                <!-- datatable start -->
                                <div class="responsive-table">
                                    <table id="list-datatable" class="table table-bordered table-striped">
                                        <thead>
                                        <tr>

                                            <th> Nom</th>
                                            <th> Id du projet</th>
                                            <th></th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        @foreach ($records as $record)
                                            <tr>

                                                <td> {{ $record->name }} </td>
                                                <td> {{ $record->id_project }} </td>
                                                <td>
                                                    <a href="{{route('quickyproject.edit', ['quickyproject'=>$record->id])}}"><i
                                                            class="material-icons tooltipped" data-position="top"
                                                            data-tooltip="Modifier">edit</i></a>
                                                    <a href="#!" onclick="openSuppModal({{$record->id}})"><i
                                                            class="material-icons tooltipped" style="color: #c10027;"
                                                            data-position="top"
                                                            data-tooltip="Supprimer">delete</i></a>
                                                </td>
                                            </tr>
                                        @endforeach

                                    </table>
                                </div>
                                <!-- /.card-body -->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div style="bottom: 50px; right: 19px;" class="fixed-action-btn direction-top"><a
                    href="{{route('quickyproject.create')}}"
                    class="btn-floating btn-large gradient-45deg-light-blue-cyan gradient-shadow"><i
                        class="material-icons">add</i></a></div>
        </div>
    </div>

    <div id="delete_modal" class="modal">
        <div class="modal-content">
            <h4> Confirmation de suppression</h4>
            <div>
                Êtes-vous sûr de vouloir supprimer ?
            </div>
            <input type="hidden" name="delId" id="delId">
        </div>
        <div class="modal-footer">
            <a href="#!" class="modal-close waves-effect waves-green btn grey">Annuler</a>
            <a href="#!" class="waves-effect waves-green btn red" onclick="suppRecord()">Supprimer</a>
        </div>
    </div>
@stop
@section('js')
    <script>
        function openSuppModal(id) {
            $("#delId").val(id);
            $('#delete_modal').modal('open');
        }

        function suppRecord() {
            var id = $("#delId").val();
            $.ajax({
                url: '/quickyproject/' + id,
                type: 'DELETE',
                data: {
                    _token: $('meta[name="csrf-token"]').attr('content')
                },
                success: function (result) {
                    if (result.success) {
                        alert(result.message);
                        window.location.replace("/quickyproject");
                    } else {
                        alert("Erreur lors de la suppression!");
                    }
                },
                error: function (xhr, status, error) {
                    console.error(error);
                }
            });
        }

        $(document).ready(function () {
            $('.modal').modal();

            $('#list-datatable').DataTable({
                processing: true,
                serverSide: true,
                ajax: "{{ route('quickyproject.data') }}",
                columns: [{data: 'name', name: 'name'}, {data: 'id_project', name: 'id_project'}, {
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }],
                language: {
                    url: '/assets/vendors/data-tables/i18n/fr_fr.json'
                },
            });
        });
    </script>
@stop